<?php
include 'exportProtect.php';
session_start();
 
//echo '<pre>';						//Dient zu Formatierungszwecken bei der Demo-Textausgabe
//Make the file downloadable - for testing purposes disable the line below (//) and enable line 5
header("Content-disposition: attachment; filename=export_bm_" .$_GET['survey']. "_" .$_GET['title']. ".csv");
error_reporting(NULL);
//error_reporting(E_ALL);

class ExportHandler {
//Handles the export process of Performance Benchmarkersurvey data
	
	//Klassenvariablen
	private $separator = ";";		//Definiert das verwendete Trennzeichen; kann bei Bedarf beliebig gendert werden
	private $survey;
	private $mailtable;	
	private $mode;
	private $title;
	private $dropColumns = 2; 		// Describes how many columns per table will be omitted when generating the export
	//If DB-Layout changes (additional fields/columns are added), these fields have to be placed before the questions and
	//$dropColumns has to be increased by the amount of added fields/columns
	
	function ExportHandler($survey, $mailtable, $mode, $title) {
		//Klassenvariablen mit aktuellen Parametern berschreiben
		$this->survey = $survey;
		$this->mailtable = $mailtable;
		$this->mode = $mode;
		$this->title = $title;
		
		//Verbindung mit der Datenbank aufnehmen	
		$this->connectDB();

		//Daten ausgeben
		$this->showResults();	
	}
	
	private function connectDB() {	
		//Verbindung mit der Datenbank aufnehmen
		include("../system/database/connect.inc.php");	
	}
	
	private function showResults() {
		//Show table name and export range on top
		echo bm_ . $this->survey . _ . $this->mode . _ . $this->title . "\n";

		//Output first line of table:
			
		//Define interviewee fields
		$userFields = array ("Benutzer ID");			
						
		//Define order of questions in survey
		$questions = $this->getQuestions();			
							
		//Output columns titles: 	benutzer_ID
		foreach ($userFields as $field) {
			echo $field . $this->separator;
		}

		//Output columns titles:	Fragen
		foreach ($questions	as $question) {
			foreach ($question	as $answer) {
				echo $answer . $this->separator;
			}
		}
		
		//End of the first line (title row)
		echo "\n"; 
			
		//---			
			
		// get unique users
		$result = mysql_query("SELECT benutzer_ID FROM benutzer ORDER BY benutzer_ID" );
		if (!$result) die (mysql_error());
			
			// display answers of one user per line 
			while($row = mysql_fetch_array($result)) {
				// do this for every user: 
				
				$benutzer_ID = $row['benutzer_ID'];
				echo $benutzer_ID . $this->separator;
				//echo $this->fetchMail($benutzer_ID). $this->separator;
				
				
				
				foreach ($questions	as $question=>$answers) {					
					$this->getAnswers($question, $answers, $benutzer_ID);
					//echo $question.'&&'.$answers[0].'<br>';
				}
				
				echo "\n";
				
		  }
	}
	
	private function getQuestions() {
	
		$temp=array();
		$questions=array();
		
		//Retrieve export range and read in list of questions
		if ($this->mode=='partial') {
			$list=$_SESSION['partial'];
		}elseif ($this->mode=='partial2') {
			$list=$_SESSION['partial2'];
		}elseif ($this->mode=='partial3') {
			$list=$_SESSION['partial3'];
		}else {
			die ("What do you want to export ?!");	//Not clear what to export; no mode selected
		}
		
		
		//Alle Fragen ins array schreiben
		foreach ($list as $fragen) {
		
			if(strpos($fragen,"-")!==false) {
				$begin=substr($fragen,0,strpos($fragen,"-"));
				$end=substr($fragen,strpos($fragen,"-")+1);
				
				for($i=$begin;$i<=$end;$i++) {
					if($i<10) {
						$temp[]='frage00'.$i;
					}elseif($i<100) {
						$temp[]='frage0'.$i;
					}else {
						$temp[]='frage'.$i;
					}
				}
			}elseif($fragen == 'final') {
				$temp[]='final';
			}else {
				$temp[]='frage'.$fragen;
			}
		}
		
		foreach ($temp as $table) {
			$tmp=array();
			$query = 'SHOW COLUMNS FROM '.$table;
			$result = mysql_query($query);
			if (!$result) die ( mysql_error() );
			
			while($row = mysql_fetch_array($result)) {	
				$tmp[]=$row[0];
			}
			
			for($i=$this->dropColumns;$i<count($tmp);$i++) {
				$questions[$table][]=$tmp[$i];
			}
			
		}
		
		return $questions;
	
	}

	private function getAnswers($question, $answers, $benutzer_ID) {
		//
		$q = "SELECT * FROM " . $question . " WHERE benutzer_ID = '". $benutzer_ID . "'";
		$result = mysql_query($q );
		if (!$result) die ( mysql_error() );
		
		//falls user frage nicht ausgefllt hat, dann semikolons einfgen
		if (mysql_num_rows($result) == 0) {
			for ($i=0;$i<count($answers);$i++){
				echo $this->separator;
			}
		}
		
		while($row = mysql_fetch_array($result)) {
			foreach($answers as $answer) {
				// find and replace semicolons
				echo str_replace(";", ",", $row[$answer]) . $this->separator;
			}
		}	
	
	}
  
  /*
  private function questionExists($question) {
	$return = ""; 
	$result = mysql_query("SELECT frage_ID FROM " . $this->tableName . " WHERE frage_ID = '".$question."'" );
	if (!$result) die ( mysql_error() );
	while($row = mysql_fetch_array($result))
	{	
		if ($row['frage_ID'] == NULL ) return false;
			else return true;
	}
  }
  
    private function benutzerID2Name ($benutzerID) {
	$return = ""; 
	$result = mysql_query("SELECT benutzer_vorname, benutzer_nachname FROM benutzer WHERE benutzer_ID = '$benutzerID'" );

	while($row = mysql_fetch_array($result))
	{	
		$return = $row['benutzer_vorname']. " " . $row['benutzer_nachname']; 
		return $return;
	}
  }
  */
  
	
  
	private function fetchMail($benutzerID) {
		$return = ";"; 
		$result = mysql_query("SELECT * FROM " . $this->mailtable . " WHERE benutzer_ID = '".$benutzerID."'" );
		if (!$result) die ( mysql_error() );
		while($row = mysql_fetch_array($result)) {	
			$return = $row[$this->mailtable."_1"] . $this->separator . $row[$this->mailtable."_2"];	
		}
		return $return;
	}
  
  
  }
 
//Bypass/avoid max_execution_time 
//Only working if php_safe_mode=off
//Example:
//set_time_limit(20) increases the max_execution_time value by 20 seconds
//set time_limit(0) = unlimited
set_time_limit(0);

$survey = $_GET['survey'];
$mailtable = $_GET['mailtable'];
$mode = $_GET['mode'];
$title = $_GET['title']; 

$exportSurvey = new ExportHandler($survey, $mailtable, $mode, $title);
?>